/*
 * @(#)port.c 1.15      87/11/05        Public Domain, by John Gilmore, 1986
 *
 * These are routines not available in all environments.
 *
 * I know this introduces an extra level of subroutine calls and is
 * slightly slower.  Frankly, my dear, I don't give a damn.  Let the
 * Missed-Em Vee losers suffer a little.  This software is proud to
 * have been written on a BSD system.
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>
#include <errno.h>

#if defined(MSDOS) || defined(QDOS)
#include <fcntl.h>
#else
#include <sys/file.h>
#endif

#include <unistd.h>

#include "tar.h"

#ifndef NULL
#define NULL 0
#endif

/*
 * Some people (e.g. V7) don't have a #define for these.
 */
#ifndef O_BINARY
#define O_BINARY        0
#endif
#ifndef O_RDONLY
#define O_RDONLY        0
#endif


#include "port.h"


/*
 * Some computers are not so crass as to align themselves into the BSD
 * or USG camps.  If a system supplies all of the routines we fake here,
 * add it to the list in the #ifndefs below and it'll all be skipped.
 * Make sure to add a matching #endif at the end of the file!
 *
 * We are avoiding #if defined() here for the sake of Minix, which comes
 * with the severely broken Amsterdam Compiler Kit.  Thanks, Andy!
 */

/*
 * valloc() does a malloc() on a page boundary.  On some systems,
 * this can make large block I/O more efficient.
 */
char * valloc (size)
        unsigned size;
{
    char *p = malloc (size);
    if(p == NULL)
    {
        fputs("Out of memory\n", stderr);
        exit(0);
    }
    return p;
}

link(path1, path2)
        char            *path1;
        char            *path2;
{
        char    buf[256];
        int     ifd, ofd;
        int     nrbytes;
        int     nwbytes;

        fprintf(stderr, "%s: %s: cannot link to %s, copying instead\n",
                tar, path1, path2);
        if ((ifd = open(path1, O_RDONLY|O_BINARY)) < 0)
                return -1;
        if ((ofd = creat(path2, 0666)) < 0)
                return -1;

        while ((nrbytes = read(ifd, buf, sizeof(buf))) > 0) {
                if ((nwbytes = write(ofd, buf, nrbytes)) != nrbytes) {
                        nrbytes = -1;
                        break;
                }
        }
        /* Note use of "|" rather than "||" below: we want to close
         * the files even if an error occurs.
         */
        if ((nrbytes < 0) | (0 != close(ifd)) | (0 != close(ofd))) {
                unlink(path2);
                return -1;
        }
        return 0;
}
